Index: sys/thread.h
===================================================================
RCS file: /cvs/src/sys/sys/thread.h,v
retrieving revision 1.46
diff -u -r1.46 thread.h
--- sys/thread.h	17 Feb 2004 19:38:50 -0000	1.46
+++ sys/thread.h	23 Feb 2004 04:18:12 -0000
@@ -31,6 +31,7 @@
 struct thread;
 struct lwkt_queue;
 struct lwkt_token;
+struct lwkt_tokref;
 struct lwkt_wait;
 struct lwkt_ipiq;
 struct lwkt_cpu_msg;
@@ -43,6 +44,7 @@
 
 typedef struct lwkt_queue	*lwkt_queue_t;
 typedef struct lwkt_token	*lwkt_token_t;
+typedef struct lwkt_tokref	*lwkt_tokref_t;
 typedef struct lwkt_wait	*lwkt_wait_t;
 typedef struct lwkt_cpu_msg	*lwkt_cpu_msg_t;
 typedef struct lwkt_cpu_port	*lwkt_cpu_port_t;
@@ -72,17 +74,44 @@
 #endif
 
 /*
- * Tokens arbitrate access to information.  They are 'soft' arbitrators
- * in that they are associated with cpus rather then threads, making the
- * optimal aquisition case very fast if your cpu already happens to own the
- * token you are requesting.
+ * Tokens are used to serialize access to information.  They are 'soft'
+ * serialization entities that only stay in effect while the thread is
+ * running.  If the thread blocks, other threads can run holding the same
+ * tokens.  The tokens are reacquired when the original thread resumes.
+ *
+ * A thread can depend on its serialization remaining intact through a
+ * preemption.  An interrupt which attempts to use the same token as the
+ * thread being preempted will reschedule itself for non-preemptive
+ * operation, so the new token code is capable of interlocking against
+ * interrupts as well as other cpus.
+ *
+ * Tokens are managed through a helper reference structure, lwkt_tokref,
+ * which is typically declared on the caller's stack.  Multiple tokref's
+ * may reference the same token.
  */
 typedef struct lwkt_token {
-    struct globaldata *t_cpu;	/* the current owner of the token */
-    struct globaldata *t_reqcpu;/* return ownership to this cpu on release */
-    int		t_gen;		/* generation number */
+    struct globaldata	*t_cpu;		/* the current owner of the token */
+    struct globaldata	*t_reqcpu;	/* requesting cpu */
+    int			t_unused01;	/* (used to be generation number) */
 } lwkt_token;
 
+typedef struct lwkt_tokref {
+    lwkt_token_t	tr_tok;		/* token in question */
+    __uint32_t		tr_magic;	/* sanity check */
+    lwkt_tokref_t	tr_next;	/* linked list */
+    lwkt_tokref_t	tr_gdreqnext;	/* based at gd_tokreqbase */
+    struct globaldata	*tr_reqgd;	/* requesting cpu */
+} lwkt_tokref;
+
+#define LWKT_TOKREF_MAGIC1		\
+			((__uint32_t)0x544f4b52)	/* normal */
+#define LWKT_TOKREF_MAGIC2		\
+			((__uint32_t)0x544f4b53)	/* pending req */
+#define LWKT_TOKREF_INIT(tok)		\
+			{ tok, LWKT_TOKREF_MAGIC1 }
+#define LWKT_TOKREF_DECLARE(name, tok)	\
+			lwkt_tokref name = LWKT_TOKREF_INIT(tok)
+
 /*
  * Wait structures deal with blocked threads.  Due to the way remote cpus
  * interact with these structures stable storage must be used.
@@ -96,6 +125,7 @@
 
 #define MAXCPUFIFO      16	/* power of 2 */
 #define MAXCPUFIFO_MASK	(MAXCPUFIFO - 1)
+#define LWKT_MAXTOKENS	16	/* max tokens beneficially held by thread */
 
 /*
  * Always cast to ipifunc_t when registering an ipi.  The actual ipi function
@@ -207,6 +237,7 @@
     char	td_comm[MAXCOMLEN+1]; /* typ 16+1 bytes */
     struct thread *td_preempted; /* we preempted this thread */
     struct caps_kinfo *td_caps;	/* list of client and server registrations */
+    lwkt_tokref_t td_toks;	/* tokens beneficially held */
     struct md_thread td_mach;
 };
 
@@ -283,7 +314,7 @@
 extern void lwkt_set_comm(thread_t td, const char *ctl, ...);
 extern void lwkt_wait_free(struct thread *td);
 extern void lwkt_free_thread(struct thread *td);
-extern void lwkt_init_wait(struct lwkt_wait *w);
+extern void lwkt_wait_init(struct lwkt_wait *w);
 extern void lwkt_gdinit(struct globaldata *gd);
 extern void lwkt_switch(void);
 extern void lwkt_maybe_switch(void);
@@ -295,28 +326,44 @@
 extern void lwkt_acquire(thread_t td);
 extern void lwkt_yield(void);
 extern void lwkt_yield_quick(void);
+extern void lwkt_token_wait(void);
 extern void lwkt_hold(thread_t td);
 extern void lwkt_rele(thread_t td);
 
 extern void lwkt_block(lwkt_wait_t w, const char *wmesg, int *gen);
 extern void lwkt_signal(lwkt_wait_t w, int count);
-extern int lwkt_trytoken(lwkt_token_t tok);
-extern int lwkt_gettoken(lwkt_token_t tok);
-extern int lwkt_gentoken(lwkt_token_t tok, int *gen);
-extern int lwkt_reltoken(lwkt_token_t tok);
-extern void lwkt_inittoken(lwkt_token_t tok);
-extern int  lwkt_regettoken(lwkt_token_t tok);
+
+extern int lwkt_havetoken(lwkt_token_t tok);
+extern int lwkt_havetokref(lwkt_tokref_t xref);
+extern void lwkt_gettoken(lwkt_tokref_t ref, lwkt_token_t tok);
+extern int lwkt_trytoken(lwkt_tokref_t ref, lwkt_token_t tok);
+extern void lwkt_gettokref(lwkt_tokref_t ref);
+extern int  lwkt_trytokref(lwkt_tokref_t ref);
+extern void lwkt_reltoken(lwkt_tokref_t ref);
+extern void lwkt_reqtoken_remote(void *data);
+extern int  lwkt_chktokens(thread_t td);
+extern void lwkt_drain_token_requests(void);
+extern void lwkt_token_init(lwkt_token_t tok);
+extern void lwkt_token_uninit(lwkt_token_t tok);
+
+extern void lwkt_token_pool_init(void);
+extern lwkt_token_t lwkt_token_pool_get(void *ptraddr);
+
 extern void lwkt_rwlock_init(lwkt_rwlock_t lock);
+extern void lwkt_rwlock_uninit(lwkt_rwlock_t lock);
 extern void lwkt_exlock(lwkt_rwlock_t lock, const char *wmesg);
 extern void lwkt_shlock(lwkt_rwlock_t lock, const char *wmesg);
 extern void lwkt_exunlock(lwkt_rwlock_t lock);
 extern void lwkt_shunlock(lwkt_rwlock_t lock);
+
 extern void lwkt_setpri(thread_t td, int pri);
 extern void lwkt_setpri_self(int pri);
 extern int  lwkt_send_ipiq(struct globaldata *targ, ipifunc_t func, void *arg);
+extern int  lwkt_send_ipiq_passive(struct globaldata *targ, ipifunc_t func, void *arg);
 extern int  lwkt_send_ipiq_bycpu(int dcpu, ipifunc_t func, void *arg);
 extern int  lwkt_send_ipiq_mask(cpumask_t mask, ipifunc_t func, void *arg);
 extern void lwkt_wait_ipiq(struct globaldata *targ, int seq);
+extern int  lwkt_seq_ipiq(struct globaldata *targ);
 extern void lwkt_process_ipiq(void);
 #ifdef _KERNEL
 extern void lwkt_process_ipiq_frame(struct intrframe frame);
Index: sys/thread2.h
===================================================================
RCS file: /cvs/src/sys/sys/thread2.h,v
retrieving revision 1.12
diff -u -r1.12 thread2.h
--- sys/thread2.h	10 Feb 2004 07:34:43 -0000	1.12
+++ sys/thread2.h	21 Feb 2004 22:23:41 -0000
@@ -102,10 +102,16 @@
     curthread->td_pri = cpri;
 }
 
-static __inline int
-lwkt_havetoken(lwkt_token_t tok)
+/*
+ * Initialize a tokref_t.  We only need to initialize the token pointer
+ * and the magic number.  We do not have to initialize tr_next, tr_gdreqnext,
+ * or tr_reqgd.
+ */
+static __inline void
+lwkt_tokref_init(lwkt_tokref_t ref, lwkt_token_t tok)
 {
-    return (tok->t_cpu == mycpu);
+    ref->tr_magic = LWKT_TOKREF_MAGIC1;
+    ref->tr_tok = tok;
 }
 
 /*
Index: sys/vnode.h
===================================================================
RCS file: /cvs/src/sys/sys/vnode.h,v
retrieving revision 1.9
diff -u -r1.9 vnode.h
--- sys/vnode.h	20 Jan 2004 18:41:51 -0000	1.9
+++ sys/vnode.h	22 Feb 2004 21:34:42 -0000
@@ -116,7 +116,7 @@
 	daddr_t	v_lasta;			/* last allocation */
 	int	v_clen;				/* length of current cluster */
 	struct vm_object *v_object;		/* Place to store VM object */
-	struct	lwkt_token v_interlock;		/* lock on usecount and flag */
+	lwkt_token_t v_interlock;		/* lock on usecount and flag */
 	struct	lock *v_vnlock;			/* used for non-locking fs's */
 	enum	vtagtype v_tag;			/* type of underlying data */
 	void 	*v_data;			/* private data for fs */
@@ -175,6 +175,7 @@
 #define	VONWORKLST	0x200000 /* On syncer work-list */
 #define	VMOUNT		0x400000 /* Mount in progress */
 #define VOBJDIRTY	0x800000 /* object might be dirty */
+#define VPLACEMARKER	0x1000000 /* dummy vnode placemarker */
 
 /*
  * Vnode attributes.  A field value of VNOVAL represents a field whose value
@@ -325,8 +326,8 @@
 	(((vp)->v_flag & VFREE) && \
 	 ((vp)->v_holdcnt || (vp)->v_usecount))
 
-#define	VI_LOCK(vp)	lwkt_gettoken(&(vp)->v_interlock)
-#define	VI_UNLOCK(vp)	lwkt_reltoken(&(vp)->v_interlock)
+#define	VI_LOCK(vlock, vp)	lwkt_gettoken(vlock, (vp)->v_interlock)
+#define	VI_UNLOCK(vlock, vp)	lwkt_reltoken(vlock)
 
 #endif /* _KERNEL */
 
@@ -576,24 +577,29 @@
 void	vfs_add_vnodeops (const void *);
 void	vfs_rm_vnodeops (const void *);
 int	vflush (struct mount *mp, int rootrefs, int flags);
-int 	vget (struct vnode *vp, int lockflag, struct thread *td);
+int	vmntvnodescan(struct mount *mp, 
+	    int (*fastfunc)(struct mount *mp, struct vnode *vp, void *data),
+	    int (*slowfunc)(struct mount *mp, struct vnode *vp, lwkt_tokref_t vlock, void *data),
+	    void *data);
+
+int 	vget (struct vnode *vp, lwkt_tokref_t vlock, int lockflag, struct thread *td);
 void 	vgone (struct vnode *vp);
-void	vgonel (struct vnode *vp, struct thread *td);
+void	vgonel (struct vnode *vp, lwkt_tokref_t vlock, struct thread *td);
 void	vhold (struct vnode *);
 int	vinvalbuf (struct vnode *vp, int save, 
 	    struct thread *td, int slpflag, int slptimeo);
 int	vtruncbuf (struct vnode *vp, struct thread *td,
 		off_t length, int blksize);
 void	vprint (char *label, struct vnode *vp);
-int	vrecycle (struct vnode *vp, struct lwkt_token *inter_lkp,
+int	vrecycle (struct vnode *vp, struct lwkt_tokref *inter_lkp,
 	    struct thread *td);
 int 	vn_close (struct vnode *vp, int flags, struct thread *td);
 int	vn_isdisk (struct vnode *vp, int *errp);
-int	vn_lock (struct vnode *vp, int flags, struct thread *td);
+int	vn_lock (struct vnode *vp, lwkt_tokref_t vlock, int flags, struct thread *td);
 #ifdef	DEBUG_LOCKS
-int	debug_vn_lock (struct vnode *vp, int flags, struct thread *td,
+int	debug_vn_lock (struct vnode *vp, lwkt_tokref_t vlock, int flags, struct thread *td,
 	    const char *filename, int line);
-#define vn_lock(vp,flags,p) debug_vn_lock(vp,flags,p,__FILE__,__LINE__)
+#define vn_lock(vp,vlock,flags,p) debug_vn_lock(vp,vlock,flags,p,__FILE__,__LINE__)
 #endif
 int 	vn_open (struct nameidata *ndp, int fmode, int cmode);
 void	vn_pollevent (struct vnode *vp, int events);
Index: vfs/coda/coda_subr.c
===================================================================
RCS file: /cvs/src/sys/vfs/coda/coda_subr.c,v
retrieving revision 1.5
diff -u -r1.5 coda_subr.c
--- vfs/coda/coda_subr.c	12 Nov 2003 22:08:09 -0000	1.5
+++ vfs/coda/coda_subr.c	22 Feb 2004 19:54:49 -0000
@@ -315,9 +315,11 @@
 	int count = 0, bad = 0;
 loop:
 	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp; vp = nvp) {
+		nvp = TAILQ_NEXT(vp, v_nmntvnodes);	/* ZZZ */
+		if (vp->v_flag & VPLACEMARKER)
+			continue;
 		if (vp->v_mount != mp)
 			goto loop;
-		nvp = TAILQ_NEXT(vp, v_nmntvnodes);
 		cp = VTOC(vp);
 		count++;
 		if (!(cp->c_flags & C_UNMOUNTING)) {
Index: vfs/coda/coda_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/coda/coda_vfsops.c,v
retrieving revision 1.10
diff -u -r1.10 coda_vfsops.c
--- vfs/coda/coda_vfsops.c	23 Sep 2003 05:03:52 -0000	1.10
+++ vfs/coda/coda_vfsops.c	22 Feb 2004 06:11:37 -0000
@@ -314,11 +314,11 @@
 	    { /* Found valid root. */
 		*vpp = mi->mi_rootvp;
 		/* On Mach, this is vref.  On NetBSD, VOP_LOCK */
-#if	1
+#if 1
 		vref(*vpp);
-		vn_lock(*vpp, LK_EXCLUSIVE, td);
+		vn_lock(*vpp, NULL, LK_EXCLUSIVE, td);
 #else
-		vget(*vpp, LK_EXCLUSIVE, td);
+		vget(*vpp, NULL, LK_EXCLUSIVE, td);
 #endif
 		MARK_INT_SAT(CODA_ROOT_STATS);
 		return(0);
@@ -339,9 +339,9 @@
 	*vpp = mi->mi_rootvp;
 #if	1
 	vref(*vpp);
-	vn_lock(*vpp, LK_EXCLUSIVE, td);
+	vn_lock(*vpp, NULL, LK_EXCLUSIVE, td);
 #else
-	vget(*vpp, LK_EXCLUSIVE, td);
+	vget(*vpp, NULL, LK_EXCLUSIVE, td);
 #endif
 
 	MARK_INT_SAT(CODA_ROOT_STATS);
@@ -359,9 +359,9 @@
 	*vpp = mi->mi_rootvp;
 #if	1
 	vref(*vpp);
-	vn_lock(*vpp, LK_EXCLUSIVE, td);
+	vn_lock(*vpp, NULL, LK_EXCLUSIVE, td);
 #else
-	vget(*vpp, LK_EXCLUSIVE, td);
+	vget(*vpp, NULL, LK_EXCLUSIVE, td);
 #endif
 
 	MARK_INT_FAIL(CODA_ROOT_STATS);
Index: vfs/coda/coda_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/coda/coda_vnops.c,v
retrieving revision 1.13
diff -u -r1.13 coda_vnops.c
--- vfs/coda/coda_vnops.c	16 Feb 2004 19:56:26 -0000	1.13
+++ vfs/coda/coda_vnops.c	22 Feb 2004 07:30:02 -0000
@@ -272,7 +272,7 @@
 	return (error);
 
     /* We get the vnode back locked.  Needs unlocked */
-    VOP_UNLOCK(vp, 0, td);
+    VOP_UNLOCK(vp, NULL, 0, td);
     /* Keep a reference until the close comes in. */
     vref(*vpp);                
 
@@ -450,7 +450,7 @@
 	     * We get the vnode back locked in both Mach and
 	     * NetBSD.  Needs unlocked 
 	     */
-	    VOP_UNLOCK(cfvp, 0, td);
+	    VOP_UNLOCK(cfvp, NULL, 0, td);
 	}
 	else {
 	    opened_internally = 1;
@@ -916,7 +916,7 @@
 	    printf("coda_inactive: cp->ovp != NULL use %d: vp %p, cp %p\n",
 	    	   vp->v_usecount, vp, cp);
 #endif
-	lockmgr(&cp->c_lock, LK_RELEASE, &vp->v_interlock, td);
+	lockmgr(&cp->c_lock, LK_RELEASE, NULL, td);
     } else {
 #ifdef OLD_DIAGNOSTIC
 	if (CTOV(cp)->v_usecount) {
@@ -926,7 +926,7 @@
 	    panic("coda_inactive:  cp->ovp != NULL");
 	}
 #endif
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	vgone(vp);
     }
 
@@ -1072,7 +1072,7 @@
      */
     if (!error || (error == EJUSTRETURN)) {
 	if (!(cnp->cn_flags & CNP_LOCKPARENT) || !(cnp->cn_flags & CNP_ISLASTCN)) {
-	    if ((error = VOP_UNLOCK(dvp, 0, td))) {
+	    if ((error = VOP_UNLOCK(dvp, NULL, 0, td))) {
 		return error; 
 	    }	    
 	    /* 
@@ -1080,7 +1080,7 @@
 	     * lock it without bothering to check anything else. 
 	     */
 	    if (*ap->a_vpp) {
-		if ((error = VOP_LOCK(*ap->a_vpp, LK_EXCLUSIVE, td))) {
+		if ((error = VOP_LOCK(*ap->a_vpp, NULL, LK_EXCLUSIVE, td))) {
 		    printf("coda_lookup: ");
 		    panic("unlocked parent but couldn't lock child");
 		}
@@ -1089,7 +1089,7 @@
 	    /* The parent is locked, and may be the same as the child */
 	    if (*ap->a_vpp && (*ap->a_vpp != dvp)) {
 		/* Different, go ahead and lock it. */
-		if ((error = VOP_LOCK(*ap->a_vpp, LK_EXCLUSIVE, td))) {
+		if ((error = VOP_LOCK(*ap->a_vpp, NULL, LK_EXCLUSIVE, td))) {
 		    printf("coda_lookup: ");
 		    panic("unlocked parent but couldn't lock child");
 		}
@@ -1178,7 +1178,7 @@
 
     if (!error) {
 	if (cnp->cn_flags & CNP_LOCKLEAF) {
-	    if ((error = VOP_LOCK(*ap->a_vpp, LK_EXCLUSIVE, td))) {
+	    if ((error = VOP_LOCK(*ap->a_vpp, NULL, LK_EXCLUSIVE, td))) {
 		printf("coda_create: ");
 		panic("unlocked parent but couldn't lock child");
 	    }
@@ -1780,9 +1780,9 @@
     }
 
 #ifndef	DEBUG_LOCKS
-    return (lockmgr(&cp->c_lock, ap->a_flags, &vp->v_interlock, td));
+    return (lockmgr(&cp->c_lock, ap->a_flags, ap->a_vlock, td));
 #else
-    return (debuglockmgr(&cp->c_lock, ap->a_flags, &vp->v_interlock, td,
+    return (debuglockmgr(&cp->c_lock, ap->a_flags, ap->a_vlock, td,
 			 "coda_lock", vp->filename, vp->line));
 #endif
 }
@@ -1805,7 +1805,7 @@
 		  cp->c_fid.Volume, cp->c_fid.Vnode, cp->c_fid.Unique));
     }
 
-    return (lockmgr(&cp->c_lock, ap->a_flags | LK_RELEASE, &vp->v_interlock, td));
+    return (lockmgr(&cp->c_lock, ap->a_flags | LK_RELEASE, ap->a_vlock, td));
 }
 
 int
Index: vfs/deadfs/dead_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/deadfs/dead_vnops.c,v
retrieving revision 1.6
diff -u -r1.6 dead_vnops.c
--- vfs/deadfs/dead_vnops.c	20 Aug 2003 09:56:31 -0000	1.6
+++ vfs/deadfs/dead_vnops.c	22 Feb 2004 06:21:10 -0000
@@ -201,6 +201,7 @@
 dead_lock(ap)
 	struct vop_lock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct proc *a_p;
 	} */ *ap;
@@ -212,7 +213,7 @@
 	 * the interlock here.
 	 */
 	if (ap->a_flags & LK_INTERLOCK) {
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(ap->a_vlock);
 		ap->a_flags &= ~LK_INTERLOCK;
 	}
 	if (!chkvnlock(vp))
Index: vfs/fdesc/fdesc_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/fdesc/fdesc_vfsops.c,v
retrieving revision 1.5
diff -u -r1.5 fdesc_vfsops.c
--- vfs/fdesc/fdesc_vfsops.c	20 Aug 2003 09:56:31 -0000	1.5
+++ vfs/fdesc/fdesc_vfsops.c	22 Feb 2004 05:54:09 -0000
@@ -149,7 +149,7 @@
 	 */
 	vp = VFSTOFDESC(mp)->f_root;
 	VREF(vp);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	*vpp = vp;
 	return (0);
 }
Index: vfs/fdesc/fdesc_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/fdesc/fdesc_vnops.c,v
retrieving revision 1.8
diff -u -r1.8 fdesc_vnops.c
--- vfs/fdesc/fdesc_vnops.c	23 Sep 2003 05:03:52 -0000	1.8
+++ vfs/fdesc/fdesc_vnops.c	22 Feb 2004 06:11:53 -0000
@@ -112,7 +112,7 @@
 loop:
 	LIST_FOREACH(fd, fc, fd_hash) {
 		if (fd->fd_ix == ix && fd->fd_vnode->v_mount == mp) {
-			if (vget(fd->fd_vnode, 0, td))
+			if (vget(fd->fd_vnode, NULL, 0, td))
 				goto loop;
 			*vpp = fd->fd_vnode;
 			return (error);
@@ -191,11 +191,11 @@
 		goto bad;
 	}
 
-	VOP_UNLOCK(dvp, 0, td);
+	VOP_UNLOCK(dvp, NULL, 0, td);
 	if (cnp->cn_namelen == 1 && *pname == '.') {
 		*vpp = dvp;
 		VREF(dvp);	
-		vn_lock(dvp, LK_SHARED | LK_RETRY, td);
+		vn_lock(dvp, NULL, LK_SHARED | LK_RETRY, td);
 		return (0);
 	}
 
@@ -227,12 +227,12 @@
 	if (error)
 		goto bad;
 	VTOFDESC(fvp)->fd_fd = fd;
-	vn_lock(fvp, LK_SHARED | LK_RETRY, td);
+	vn_lock(fvp, NULL, LK_SHARED | LK_RETRY, td);
 	*vpp = fvp;
 	return (0);
 
 bad:
-	vn_lock(dvp, LK_SHARED | LK_RETRY, td);
+	vn_lock(dvp, NULL, LK_SHARED | LK_RETRY, td);
 	*vpp = NULL;
 	return (error);
 }
@@ -514,7 +514,7 @@
 	 * Clear out the v_type field to avoid
 	 * nasty things happening in vgone().
 	 */
-	VOP_UNLOCK(vp, 0, ap->a_td);
+	VOP_UNLOCK(vp, NULL, 0, ap->a_td);
 	vp->v_type = VNON;
 	return (0);
 }
Index: vfs/fifofs/fifo_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/fifofs/fifo_vnops.c,v
retrieving revision 1.12
diff -u -r1.12 fifo_vnops.c
--- vfs/fifofs/fifo_vnops.c	4 Sep 2003 23:46:59 -0000	1.12
+++ vfs/fifofs/fifo_vnops.c	22 Feb 2004 05:54:29 -0000
@@ -225,10 +225,10 @@
 	}
 	if ((ap->a_mode & FREAD) && (ap->a_mode & O_NONBLOCK) == 0) {
 		if (fip->fi_writers == 0) {
-			VOP_UNLOCK(vp, 0, ap->a_td);
+			VOP_UNLOCK(vp, NULL, 0, ap->a_td);
 			error = tsleep((caddr_t)&fip->fi_readers,
 			    PCATCH, "fifoor", 0);
-			vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, ap->a_td);
+			vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, ap->a_td);
 			if (error)
 				goto bad;
 			/*
@@ -246,10 +246,10 @@
 			}
 		} else {
 			if (fip->fi_readers == 0) {
-				VOP_UNLOCK(vp, 0, ap->a_td);
+				VOP_UNLOCK(vp, NULL, 0, ap->a_td);
 				error = tsleep((caddr_t)&fip->fi_writers,
 				    PCATCH, "fifoow", 0);
-				vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, ap->a_td);
+				vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, ap->a_td);
 				if (error)
 					goto bad;
 				/*
@@ -293,10 +293,10 @@
 	if (ap->a_ioflag & IO_NDELAY)
 		rso->so_state |= SS_NBIO;
 	startresid = uio->uio_resid;
-	VOP_UNLOCK(ap->a_vp, 0, td);
+	VOP_UNLOCK(ap->a_vp, NULL, 0, td);
 	error = soreceive(rso, (struct sockaddr **)0, uio, (struct mbuf **)0,
 	    (struct mbuf **)0, (int *)0);
-	vn_lock(ap->a_vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(ap->a_vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (ap->a_ioflag & IO_NDELAY)
 		rso->so_state &= ~SS_NBIO;
 	return (error);
@@ -325,10 +325,10 @@
 #endif
 	if (ap->a_ioflag & IO_NDELAY)
 		wso->so_state |= SS_NBIO;
-	VOP_UNLOCK(ap->a_vp, 0, td);
+	VOP_UNLOCK(ap->a_vp, NULL, 0, td);
 	error = sosend(wso, (struct sockaddr *)0, ap->a_uio, 0,
 		       (struct mbuf *)0, 0, td);
-	vn_lock(ap->a_vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(ap->a_vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (ap->a_ioflag & IO_NDELAY)
 		wso->so_state &= ~SS_NBIO;
 	return (error);
@@ -510,7 +510,7 @@
 		struct thread *a_td;
 	} */ *ap;
 {
-	VOP_UNLOCK(ap->a_vp, 0, ap->a_td);
+	VOP_UNLOCK(ap->a_vp, NULL, 0, ap->a_td);
 	return (0);
 }
 
Index: vfs/gnu/ext2fs/ext2_lookup.c
===================================================================
RCS file: /cvs/src/sys/vfs/gnu/ext2fs/ext2_lookup.c,v
retrieving revision 1.8
diff -u -r1.8 ext2_lookup.c
--- vfs/gnu/ext2fs/ext2_lookup.c	9 Oct 2003 22:27:22 -0000	1.8
+++ vfs/gnu/ext2fs/ext2_lookup.c	22 Feb 2004 05:54:35 -0000
@@ -539,7 +539,7 @@
 		 */
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent)
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 		return (EJUSTRETURN);
 	}
 	/*
@@ -617,7 +617,7 @@
 		}
 		*vpp = tdp;
 		if (!lockparent)
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 		return (0);
 	}
 
@@ -642,7 +642,7 @@
 		*vpp = tdp;
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent)
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 		return (0);
 	}
 
@@ -667,13 +667,13 @@
 	 */
 	pdp = vdp;
 	if (flags & CNP_ISDOTDOT) {
-		VOP_UNLOCK(pdp, 0, td);	/* race to get the inode */
+		VOP_UNLOCK(pdp, NULL, 0, td);	/* race to get the inode */
 		if ((error = VFS_VGET(vdp->v_mount, dp->i_ino, &tdp)) != 0) {
-			vn_lock(pdp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(pdp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			return (error);
 		}
 		if (lockparent && (flags & CNP_ISLASTCN) &&
-		    (error = vn_lock(pdp, LK_EXCLUSIVE, td))) {
+		    (error = vn_lock(pdp, NULL, LK_EXCLUSIVE, td))) {
 			vput(tdp);
 			return (error);
 		}
@@ -685,7 +685,7 @@
 		if ((error = VFS_VGET(vdp->v_mount, dp->i_ino, &tdp)) != 0)
 			return (error);
 		if (!lockparent || !(flags & CNP_ISLASTCN))
-			VOP_UNLOCK(pdp, 0, td);
+			VOP_UNLOCK(pdp, NULL, 0, td);
 		*vpp = tdp;
 	}
 
Index: vfs/gnu/ext2fs/ext2_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/gnu/ext2fs/ext2_vfsops.c,v
retrieving revision 1.11
diff -u -r1.11 ext2_vfsops.c
--- vfs/gnu/ext2fs/ext2_vfsops.c	23 Sep 2003 05:03:52 -0000	1.11
+++ vfs/gnu/ext2fs/ext2_vfsops.c	22 Feb 2004 22:18:12 -0000
@@ -211,7 +211,7 @@
 			flags = WRITECLOSE;
 			if (mp->mnt_flag & MNT_FORCE)
 				flags |= FORCECLOSE;
-			if (vfs_busy(mp, LK_NOWAIT, 0, td))
+			if (vfs_busy(mp, LK_NOWAIT, NULL, td))
 				return (EBUSY);
 			error = ext2_flushfiles(mp, flags, td);
 			vfs_unbusy(mp, td);
@@ -235,13 +235,13 @@
 			 * that user has necessary permissions on the device.
 			 */
 			if (cred->cr_uid != 0) {
-				vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+				vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 				if ((error = VOP_ACCESS(devvp, VREAD | VWRITE,
 				    cred, td)) != 0) {
-					VOP_UNLOCK(devvp, 0, td);
+					VOP_UNLOCK(devvp, NULL, 0, td);
 					return (error);
 				}
-				VOP_UNLOCK(devvp, 0, td);
+				VOP_UNLOCK(devvp, NULL, 0, td);
 			}
 
 			if ((fs->s_es->s_state & EXT2_VALID_FS) == 0 ||
@@ -291,12 +291,12 @@
 		accessmode = VREAD;
 		if ((mp->mnt_flag & MNT_RDONLY) == 0)
 			accessmode |= VWRITE;
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		if ((error = VOP_ACCESS(devvp, accessmode, cred, td)) != 0) {
 			vput(devvp);
 			return (error);
 		}
-		VOP_UNLOCK(devvp, 0, td);
+		VOP_UNLOCK(devvp, NULL, 0, td);
 	}
 
 	if ((mp->mnt_flag & MNT_UPDATE) == 0) {
@@ -520,19 +520,31 @@
  *	5) invalidate all cached file data.
  *	6) re-read inode data for all active vnodes.
  */
+static int ext2_reload_scan1(struct mount *mp, struct vnode *vp, void *rescan);
+static int ext2_reload_scan2(struct mount *mp, struct vnode *vp, 
+				lwkt_tokref_t vlock, void *rescan);
+
+struct scaninfo {
+	int rescan;
+	int allerror;
+	int waitfor;
+	thread_t td;
+	struct vnode *devvp;
+	struct ext2_sb_info *fs;
+};
+
 static int
 ext2_reload(mountp, cred, td)
 	struct mount *mountp;
 	struct ucred *cred;
 	struct thread *td;
 {
-	struct vnode *vp, *nvp, *devvp;
-	struct inode *ip;
+	struct vnode *devvp;
 	struct buf *bp;
 	struct ext2_super_block * es;
 	struct ext2_sb_info *fs;
 	int error;
-	int gen;
+	struct scaninfo scaninfo;
 
 	if ((mountp->mnt_flag & MNT_RDONLY) == 0)
 		return (EINVAL);
@@ -566,54 +578,66 @@
 #endif
 	brelse(bp);
 
-	gen = lwkt_gettoken(&mntvnode_token);
-loop:
-	for (vp = TAILQ_FIRST(&mountp->mnt_nvnodelist); vp != NULL; vp = nvp) {
-		KKASSERT(vp->v_mount == mountp);
-		nvp = TAILQ_NEXT(vp, v_nmntvnodes);
-		/*
-		 * Step 4: invalidate all inactive vnodes.
-		 */
-  		if (vrecycle(vp, NULL, td)) {
-			lwkt_gentoken(&mntvnode_token, &gen);
-  			goto loop;
-		}
-		/*
-		 * Step 5: invalidate all cached file data.
-		 */
-		lwkt_gettoken(&vp->v_interlock);
-		if (lwkt_gentoken(&mntvnode_token, &gen)) {
-			lwkt_reltoken(&vp->v_interlock);
-			goto loop;
-		}
-		if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, td)) {
-			lwkt_gentoken(&mntvnode_token, &gen);
-			goto loop;
-		}
-		if (vinvalbuf(vp, 0, td, 0, 0))
-			panic("ext2_reload: dirty2");
-		/*
-		 * Step 6: re-read inode data for all active vnodes.
-		 */
-		ip = VTOI(vp);
-		error =
-		    bread(devvp, fsbtodb(fs, ino_to_fsba(fs, ip->i_number)),
-			    (int)fs->s_blocksize, &bp);
-		if (error) {
-			vput(vp);
-			lwkt_reltoken(&mntvnode_token);
-			return (error);
-		}
-		ext2_ei2di((struct ext2_inode *) ((char *)bp->b_data + 
-		    EXT2_INODE_SIZE * ino_to_fsbo(fs, ip->i_number)), 
-		    &ip->i_din);
-		brelse(bp);
+	scaninfo.rescan = 1;
+	scaninfo.td = td;
+	scaninfo.devvp = devvp;
+	scaninfo.fs = fs;
+	while (error == 0 && scaninfo.rescan) {
+	    scaninfo.rescan = 0;
+	    error = vmntvnodescan(mountp, ext2_reload_scan1, 
+				ext2_reload_scan2, &scaninfo);
+	}
+	return(error);
+}
+
+static int
+ext2_reload_scan1(struct mount *mp, struct vnode *vp, void *data)
+{
+	struct scaninfo *info = data;
+
+	/*
+	 * Step 4: invalidate all inactive vnodes.
+	 */
+	if (vrecycle(vp, NULL, curthread)) {
+		info->rescan = 1;
+		return(-1);	/* continue loop, do not call scan2 */
+	}
+	return(0);
+}
+
+static int
+ext2_reload_scan2(struct mount *mp, struct vnode *vp, lwkt_tokref_t vlock, void *data)
+{
+	struct scaninfo *info = data;
+	struct inode *ip;
+	struct buf *bp;
+	int error;
+
+	/*
+	 * Step 5: invalidate all cached file data.
+	 */
+	if (vget(vp, vlock, LK_EXCLUSIVE | LK_INTERLOCK, info->td)) {
+		info->rescan = 1;
+		return(0);
+	}
+	if (vinvalbuf(vp, 0, info->td, 0, 0))
+		panic("ext2_reload: dirty2");
+	/*
+	 * Step 6: re-read inode data for all active vnodes.
+	 */
+	ip = VTOI(vp);
+	error = bread(info->devvp, fsbtodb(info->fs, ino_to_fsba(info->fs, ip->i_number)),
+		    (int)info->fs->s_blocksize, &bp);
+	if (error) {
 		vput(vp);
-		if (lwkt_gentoken(&mntvnode_token, &gen))
-			goto loop;
+		return (error);
 	}
-	lwkt_reltoken(&mntvnode_token);
-	return (0);
+	ext2_ei2di((struct ext2_inode *) ((char *)bp->b_data + 
+	    EXT2_INODE_SIZE * ino_to_fsbo(info->fs, ip->i_number)), 
+	    &ip->i_din);
+	brelse(bp);
+	vput(vp);
+	return(0);
 }
 
 /*
@@ -653,9 +677,9 @@
 #endif
 
 	ronly = (mp->mnt_flag & MNT_RDONLY) != 0;
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_OPEN(devvp, ronly ? FREAD : FREAD|FWRITE, FSCRED, td);
-	VOP_UNLOCK(devvp, 0, td);
+	VOP_UNLOCK(devvp, NULL, 0, td);
 	if (error)
 		return (error);
 	if (devvp->v_rdev->si_iosize_max != 0)
@@ -911,73 +935,47 @@
  *
  * Note: we are always called with the filesystem marked `MPBUSY'.
  */
+
+static int ext2_sync_scan(struct mount *mp, struct vnode *vp, 
+		lwkt_tokref_t vlock, void *data);
+
 static int
 ext2_sync(mp, waitfor, td)
 	struct mount *mp;
 	int waitfor;
 	struct thread *td;
 {
-	struct vnode *nvp, *vp;
-	struct inode *ip;
 	struct ufsmount *ump = VFSTOUFS(mp);
 	struct ext2_sb_info *fs;
-	int error, allerror = 0;
-	int gen;
+	struct scaninfo scaninfo;
+	int error;
 
 	fs = ump->um_e2fs;
 	if (fs->s_dirt != 0 && fs->s_rd_only != 0) {		/* XXX */
 		printf("fs = %s\n", fs->fs_fsmnt);
 		panic("ext2_sync: rofs mod");
 	}
+
 	/*
 	 * Write back each (modified) inode.
 	 */
-	gen = lwkt_gettoken(&mntvnode_token);
-loop:
-	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp != NULL; vp = nvp) {
-		/*
-		 * If the vnode that we are about to sync is no longer
-		 * associated with this mount point, start over.
-		 */
-		if (vp->v_mount != mp) {
-			lwkt_gentoken(&mntvnode_token, &gen);
-			goto loop;
-		}
-		lwkt_gettoken(&vp->v_interlock);
-		if (lwkt_gentoken(&mntvnode_token, &gen)) {
-			lwkt_reltoken(&vp->v_interlock);
-			goto loop;
-		}
-		nvp = TAILQ_NEXT(vp, v_nmntvnodes);
-		ip = VTOI(vp);
-		if (vp->v_type == VNON ||
-		    ((ip->i_flag &
-		    (IN_ACCESS | IN_CHANGE | IN_MODIFIED | IN_UPDATE)) == 0 &&
-		    (TAILQ_EMPTY(&vp->v_dirtyblkhd) || waitfor == MNT_LAZY))) {
-			lwkt_reltoken(&vp->v_interlock);
-			continue;
-		}
-		error = vget(vp, LK_EXCLUSIVE | LK_NOWAIT | LK_INTERLOCK, td);
-		if (error) {
-			if (error == ENOENT)
-				goto loop;
-			continue;
-		}
-		if ((error = VOP_FSYNC(vp, waitfor, td)) != 0)
-			allerror = error;
-		VOP_UNLOCK(vp, 0, td);
-		vrele(vp);
-		lwkt_gentoken(&mntvnode_token, &gen);
+	scaninfo.allerror = 0;
+	scaninfo.rescan = 1;
+	scaninfo.waitfor = waitfor;
+	scaninfo.td = td;
+	while (scaninfo.rescan) {
+		scaninfo.rescan = 0;
+		vmntvnodescan(mp, NULL, ext2_sync_scan, &scaninfo);
 	}
-	lwkt_reltoken(&mntvnode_token);
+
 	/*
 	 * Force stale file system control information to be flushed.
 	 */
 	if (waitfor != MNT_LAZY) {
-		vn_lock(ump->um_devvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(ump->um_devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		if ((error = VOP_FSYNC(ump->um_devvp, waitfor, td)) != 0)
-			allerror = error;
-		VOP_UNLOCK(ump->um_devvp, 0, td);
+			scaninfo.allerror = error;
+		VOP_UNLOCK(ump->um_devvp, NULL, 0, td);
 	}
 #if QUOTA
 	qsync(mp);
@@ -989,9 +987,38 @@
 		fs->s_dirt = 0;
 		fs->s_es->s_wtime = time_second;
 		if ((error = ext2_sbupdate(ump, waitfor)) != 0)
-			allerror = error;
+			scaninfo.allerror = error;
+	}
+	return (scaninfo.allerror);
+}
+
+static int
+ext2_sync_scan(struct mount *mp, struct vnode *vp, 
+		lwkt_tokref_t vlock, void *data)
+{
+	struct scaninfo *info = data;
+	struct inode *ip;
+	int error;
+
+	ip = VTOI(vp);
+	if (vp->v_type == VNON ||
+	    ((ip->i_flag &
+	    (IN_ACCESS | IN_CHANGE | IN_MODIFIED | IN_UPDATE)) == 0 &&
+	    (TAILQ_EMPTY(&vp->v_dirtyblkhd) || info->waitfor == MNT_LAZY))) {
+		lwkt_reltoken(vlock);
+		return(0);
 	}
-	return (allerror);
+	error = vget(vp, vlock, LK_EXCLUSIVE | LK_NOWAIT | LK_INTERLOCK, info->td);
+	if (error) {
+		if (error == ENOENT)
+			info->rescan = 1;
+		return(0);
+	}
+	if ((error = VOP_FSYNC(vp, info->waitfor, info->td)) != 0)
+		info->allerror = error;
+	VOP_UNLOCK(vp, NULL, 0, info->td);
+	vrele(vp);
+	return(0);
 }
 
 /*
